



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#中的interface</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#中的interface</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 07:06:38 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>接口（interface）</strong></p>
<p>接口泛指实体把自己提供给外界的一种抽象化物（可以为另一实体），用以由内部操作分离出外部沟通方法，使其能被修改内部而不影响外界其他实体与其交互的方式。</p>
<p>接口实际上是一个约定:</p>
<p>如：IClonable, IComparable;</p>
<p>接口是抽象成员的集合：</p>
<p>ICloneable含有方法clone();</p>
<p>IComparable含有方法compare();</p>
<p>接口是一个引用类型，比抽象更抽象。</p>
<p><strong>帮助实现多重继承：</strong></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/771778/201510/771778-20151011191817893-1400791281.png" /></p>
<p><strong>接口的用处：</strong></p>
<p>1.实现不相关类的相同行为，不需要考虑这些类的层次关系；</p>
<p>2.通过接口可以了解对象的交互界面，而不需要了解对象所在的类。例如：public sealed class String: ICloneable, IComparable, IConvertible, IEnumerable.</p>
<p><strong>定义一个接口：</strong></p>
<div>
<pre class="prettyprint linenums">public interface IStringList //接口一般用I作为首字母

{<br />
    //接口声明不包括数据成员，只能包含方法、属性、事件、索引等成员<br />
    //使用接口时不能声明抽象成员（不能直接new实例化）

    void Add ( string s ) ;  

    int Count{ get; } 

    string this[int index] { get; set; } 

}

//public abstract 默认，这两个关键词不写出来</pre>
</div>
<p><strong>实现接口：</strong></p>
<div>
<pre class="prettyprint linenums">class 类名 : [父类 , ] 接口, 接口, 接口, ..... 接口

{

public 方法 () { ...... }

}</pre>
</div>
<p><strong>显示接口成员实现：</strong></p>
<p>在实现多个接口时，如果不同的接口有同名的方法，为了消除歧义，需要在方法名前写接口名： void IWindow.Close(){......};</p>
<p>调用时，只能用接口调用： (( IWindow ) f ).Close();</p>
<p><strong>接口示例：</strong></p>
<div>
<pre class="prettyprint linenums">using System;

namespace TestInterface<br />
{<br />
    interface Runner<br />
    {<br />
        void run();<br />
    }<br />
    interface Swimmer<br />
    {<br />
        void swim();<br />
    }<br />
    abstract class Animal  //抽象类用作基类<br />
    {<br />
        abstract public void eat();<br />
    }<br />
    class Person : Animal, Runner, Swimmer<br />
    {<br />
        public void run()<br />
        {<br />
            Console.WriteLine("run");<br />
        }<br />
        public void swim()<br />
        {<br />
            Console.WriteLine("swim");<br />
        }<br />
        public override void eat()<br />
        {<br />
            Console.WriteLine("eat");<br />
        }<br />
        public void speak()<br />
        {<br />
            Console.WriteLine("speak");<br />
        }<br />
    }<br />
    class Program<br />
    {<br />
        static void m1(Runner r)<br />
        {<br />
            r.run();<br />
        }<br />
        static void m2(Swimmer s)<br />
        {<br />
            s.swim();<br />
        }<br />
        static void m3(Animal a)<br />
        {<br />
            a.eat();<br />
        }<br />
        static void m4(Person p)<br />
        {<br />
            p.speak();<br />
        }

        public static void Main(string [] args)<br />
        {<br />
            Person p = new Person();<br />
            m1(p);<br />
            m2(p);<br />
            m3(p);<br />
            m4(p);<br />
            Runner a = new Person();<br />
            a.run();

            Console.ReadKey(true);<br />
        }<br />
    }<br />
}</pre>
</div>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/771778/201510/771778-20151011190904893-1132119377.png" /></p>
<p><strong>含有同名方法的多个接口继承：</strong></p>
<div>
<pre class="prettyprint linenums">using System;<br />
class InterfaceExplicitImpl<br />
{<br />
    static void Main()<br />
    {<br />
        FileViewer f = new FileViewer();<br />
        f.Test();<br />
        ( (IWindow) f ).Close();  //强制转换，消除同名歧义

        IWindow w = new FileViewer();<br />
        w.Close();

        Console.ReadKey(true);<br />
    }<br />
}

interface IWindow<br />
{<br />
    void Close();<br />
}<br />
interface IFileHandler<br />
{<br />
    void Close();<br />
}<br />
class FileViewer : IWindow, IFileHandler<br />
{<br />
    void IWindow.Close ()<br />
    {<br />
        Console.WriteLine( "Window Closed" );<br />
    }<br />
    void IFileHandler.Close()<br />
    {<br />
        Console.WriteLine( "File Closed" );<br />
    }<br />
    public void Test()<br />
    {<br />
        ( (IWindow) this ).Close(); //不同接口含有同名方法，需要在方法前面写接口名<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlkl5x8.html">linux中模块的构建，传参，和printk函数的简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw2ejrq.html">云计算的三层SPI模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7ryxg8.html">一次受限于操作系统进程数的OOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdj7x38.html">PHP包名解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdoppr8.html">Java 数据结构之ArrayList</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1v6gr9.html">Go语言的优点&lpar;oschina讨论&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xe5xm8.html">github 使用方法总结     还有一部分不太懂</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okmvnx9.html">&lpar;转&rpar;Javascript 面向对象编程（一）：封装（作者：阮一峰）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd1z0y8.html">电子设计省赛--DMA与ADC</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1202dq.html">转载   C语言中volatile关键字的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kj5m69.html">了解 &colon; Odata 的 &dollar;filter</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1mxndq.html">ES6 Module  export与import复合使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1z36q.html">设置placeholder无效解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25moxvq.html">mybatis 三剑客 generator配置 、mybatis plugin</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjkyll9.html">下载系统已经安装的rpm包</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25e54wq.html">hdu 6185 递推&plus;【矩阵快速幂】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy725v9.html">java JDBC &lpar;八&rpar; 连接池 DBCP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvovoj8.html">Centos7安装配置MySQL5&period;7</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv220r8.html">tailor 基础模版的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/902m6d3q.html">推荐一款jQuery ColorPicked 颜色拾取器插件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8zl671q.html">IOS中修改图片的大小：修改分辨率和裁剪</a>
			</li>
						<li><a href="https://www.batexi.com/a/39014gj8.html">在Python命令行和VIM中自动补全</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pv27d9.html">&lbrack;转&rsqb;backbone&period;js template&lpar;&rpar;函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mxrxp9.html">&lbrack;转&rsqb;AngularJS fixed header scrollable table directive</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8exrdjq.html">git 添加远程仓库遇到的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jxx6lq.html">WPF学习笔记（一）：数据绑定之元素到元素绑定</a>
			</li>
						<li><a href="https://www.batexi.com/a/495nyl09.html">AC日记&mdash;&mdash;字符串P型编码 openjudge 1&period;7 31</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlx7dxq.html">AC日记&mdash;&mdash;单词替换 1&period;7 21</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlx730q.html">&period;Net工程详解及项目版本管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7oojq.html">嵌入式Linux驱动学习之路&lpar;四&rpar;u-boot编译分析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
